/*	$NetBSD$	*/
/*-
 * Copyright (c) 2010 SHIMIZU Ryo <ryo@nerv.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef _ARM_IMX_IMX51_IOMUXREG_H_
#define _ARM_IMX_IMX51_IOMUXREG_H_

#define IMX51_IOMUXC_GPR0_REG						0x0000
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV47		0x00000001
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV37		0x00000002
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV46		0x00000004
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV35		0x00000008
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV25		0x00000010
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV23		0x00000020
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV24		0x00000040
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV21		0x00000080
# define IMX51_IOMUXC_GPR0_SDMA_SDMA_SEL_EV20		0x00000100
# define IMX51_IOMUXC_GPR0_SDMA_TPIU_TRACE_EN		0x00000200
# define IMX51_IOMUXC_GPR0_SDMA_EMI_MUX			0x00000400

#define IMX51_IOMUXC_GPR1_REG						0x0004
#define IMX51_IOMUXC_OBSERVE_MUX_0_REG					0x0008
#define IMX51_IOMUXC_OBSERVE_MUX_1_REG					0x000c
#define IMX51_IOMUXC_OBSERVE_MUX_2_REG					0x0010
#define IMX51_IOMUXC_OBSERVE_MUX_3_REG					0x0014
#define IMX51_IOMUXC_OBSERVE_MUX_4_REG					0x0018


/* MUX registers */
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA0_REG				0x001c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA1_REG				0x0020
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA2_REG				0x0024
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA3_REG				0x0028
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA4_REG				0x002c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA5_REG				0x0030
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA6_REG				0x0034
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA7_REG				0x0038
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA8_REG				0x003c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA9_REG				0x0040
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA10_REG			0x0044
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA11_REG			0x0048
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA12_REG			0x004c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA13_REG			0x0050
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA14_REG			0x0054
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DA15_REG			0x0058
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D16_REG				0x005c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D17_REG				0x0060
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D18_REG				0x0064
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D19_REG				0x0068
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D20_REG				0x006c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D21_REG				0x0070
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D22_REG				0x0074
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D23_REG				0x0078
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D24_REG				0x007c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D25_REG				0x0080
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D26_REG				0x0084
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D27_REG				0x0088
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D28_REG				0x008c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D29_REG				0x0090
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D30_REG				0x0094
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_D31_REG				0x0098
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A16_REG				0x009c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A17_REG				0x00a0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A18_REG				0x00a4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A19_REG				0x00a8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A20_REG				0x00ac
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A21_REG				0x00b0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A22_REG				0x00b4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A23_REG				0x00b8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A24_REG				0x00bc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A25_REG				0x00c0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A26_REG				0x00c4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_A27_REG				0x00c8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_EB0_REG				0x00cc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_EB1_REG				0x00d0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_EB2_REG				0x00d4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_EB3_REG				0x00d8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_OE_REG				0x00dc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_CS0_REG				0x00e0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_CS1_REG				0x00e4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_CS2_REG				0x00e8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_CS3_REG				0x00ec
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_CS4_REG				0x00f0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_CS5_REG				0x00f4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_DTACK_REG			0x00f8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_LBA_REG				0x00fc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_EIM_CRE_REG				0x0100
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DRAM_CS1_REG			0x0104
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_WE_B_REG			0x0108
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_RE_B_REG			0x010c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_ALE_REG			0x0110
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CLE_REG			0x0114
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_WP_B_REG			0x0118
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_RB0_REG			0x011c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_RB1_REG			0x0120
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_RB2_REG			0x0124
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_RB3_REG			0x0128
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO_NAND_REG			0x012c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CS0_REG			0x0130
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CS1_REG			0x0134
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CS2_REG			0x0138
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CS3_REG			0x013c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CS4_REG			0x0140
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CS5_REG			0x0144
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CS6_REG			0x0148
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_CS7_REG			0x014c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_RDY_INT_REG			0x0150
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D15_REG			0x0154
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D14_REG			0x0158
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D13_REG			0x015c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D12_REG			0x0160
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D11_REG			0x0164
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D10_REG			0x0168
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D9_REG			0x016c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D8_REG			0x0170
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D7_REG			0x0174
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D6_REG			0x0178
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D5_REG			0x017c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D4_REG			0x0180
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D3_REG			0x0184
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D2_REG			0x0188
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D1_REG			0x018c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_NANDF_D0_REG			0x0190
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D8_REG				0x0194
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D9_REG				0x0198
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D10_REG			0x019c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D11_REG			0x01a0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D12_REG			0x01a4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D13_REG			0x01a8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D14_REG			0x01ac
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D15_REG			0x01b0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D16_REG			0x01b4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D17_REG			0x01b8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D18_REG			0x01bc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_D19_REG			0x01c0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_VSYNC_REG			0x01c4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI1_HSYNC_REG			0x01c8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_D12_REG			0x01cc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_D13_REG			0x01d0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_D14_REG			0x01d4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_D15_REG			0x01d8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_D16_REG			0x01dc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_D17_REG			0x01e0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_D18_REG			0x01e4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_D19_REG			0x01e8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_VSYNC_REG			0x01ec
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_HSYNC_REG			0x01f0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSI2_PIXCLK_REG			0x01f4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_I2C1_CLK_REG			0x01f8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_I2C1_DAT_REG			0x01fc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_AUD3_BB_TXD_REG			0x0200
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_AUD3_BB_RXD_REG			0x0204
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_AUD3_BB_CK_REG			0x0208
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_AUD3_BB_FS_REG			0x020c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSPI1_MOSI_REG			0x0210
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSPI1_MISO_REG			0x0214
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSPI1_SS0_REG			0x0218
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSPI1_SS1_REG			0x021c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSPI1_RDY_REG			0x0220
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_CSPI1_SCLK_REG			0x0224
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_UART1_RXD_REG			0x0228
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_UART1_TXD_REG			0x022c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_UART1_RTS_REG			0x0230
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_UART1_CTS_REG			0x0234
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_UART2_RXD_REG			0x0238
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_UART2_TXD_REG			0x023c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_UART3_RXD_REG			0x0240
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_UART3_TXD_REG			0x0244
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_OWIRE_LINE_REG			0x0248
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW0_REG			0x024c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW1_REG			0x0250
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW2_REG			0x0254
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_ROW3_REG			0x0258
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_COL0_REG			0x025c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_COL1_REG			0x0260
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_COL2_REG			0x0264
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_COL3_REG			0x0268
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_COL4_REG			0x026c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_KEY_COL5_REG			0x0270
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_JTAG_DE_B_REG			0x0274
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_CLK_REG			0x0278
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DIR_REG			0x027c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_STP_REG			0x0280
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_NXT_REG			0x0284
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DATA0_REG			0x0288
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DATA1_REG			0x028c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DATA2_REG			0x0290
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DATA3_REG			0x0294
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DATA4_REG			0x0298
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DATA5_REG			0x029c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DATA6_REG			0x02a0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_USBH1_DATA7_REG			0x02a4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI1_PIN11_REG			0x02a8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI1_PIN12_REG			0x02ac
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI1_PIN13_REG			0x02b0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI1_D0_CS_REG			0x02b4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI1_D1_CS_REG			0x02b8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISPB2_SER_DIN_REG			0x02bc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISPB2_SER_DIO_REG			0x02c0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISPB2_SER_CLK_REG			0x02c4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISPB2_SER_RS_REG			0x02c8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT0_REG			0x02cc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT1_REG			0x02d0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT2_REG			0x02d4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT3_REG			0x02d8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT4_REG			0x02dc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT5_REG			0x02e0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT6_REG			0x02e4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT7_REG			0x02e8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT8_REG			0x02ec
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT9_REG			0x02f0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT10_REG			0x02f4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT11_REG			0x02f8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT12_REG			0x02fc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT13_REG			0x0300
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT14_REG			0x0304
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT15_REG			0x0308
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT16_REG			0x030c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT17_REG			0x0310
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT18_REG			0x0314
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT19_REG			0x0318
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT20_REG			0x031c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT21_REG			0x0320
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT22_REG			0x0324
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP1_DAT23_REG			0x0328
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI1_PIN3_REG			0x032c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI1_PIN2_REG			0x0330
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI_GP1_REG				0x0334
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI_GP2_REG				0x0338
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI_GP3_REG				0x033c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI2_PIN4_REG			0x0340
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI2_PIN2_REG			0x0344
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI2_PIN3_REG			0x0348
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI2_DISP_CLK_REG			0x034c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DI_GP4_REG				0x0350
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT0_REG			0x0354
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT1_REG			0x0358
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT2_REG			0x035c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT3_REG			0x0360
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT4_REG			0x0364
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT5_REG			0x0368
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT6_REG			0x036c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT7_REG			0x0370
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT8_REG			0x0374
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT9_REG			0x0378
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT10_REG			0x037c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT11_REG			0x0380
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT12_REG			0x0384
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT13_REG			0x0388
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT14_REG			0x038c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_DISP2_DAT15_REG			0x0390
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD1_CMD_REG				0x0394
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD1_CLK_REG				0x0398
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA0_REG			0x039c
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA1_REG			0x03a0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA2_REG			0x03a4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD1_DATA3_REG			0x03a8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_0_REG				0x03ac
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_1_REG				0x03b0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_REG				0x03b4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_REG				0x03b8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_REG			0x03bc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_REG			0x03c0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_REG			0x03c4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_REG			0x03c8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_2_REG				0x03cc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_3_REG				0x03d0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_PMIC_INT_REQ_REG			0x03d4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_4_REG				0x03d8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_5_REG				0x03dc
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_6_REG				0x03e0
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_7_REG				0x03e4
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_8_REG				0x03e8
#define IMX51_IOMUXC_SW_MUX_CTL_PAD_GPIO1_9_REG				0x03ec
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_ALT0		0x00000000
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_ALT1		0x00000001
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_ALT2		0x00000002
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_ALT3		0x00000003
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_ALT4		0x00000004
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_ALT5		0x00000005
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_ALT6		0x00000006
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_ALT7		0x00000007
# define IMX51_IOMUXC_SW_MUX_CTL_PAD_SION		0x00000010

/* PAD registers */
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D16_REG				0x03f0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D17_REG				0x03f4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D18_REG				0x03f8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D19_REG				0x03fc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D20_REG				0x0400
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D21_REG				0x0404
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D22_REG				0x0408
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D23_REG				0x040c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D24_REG				0x0410
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D25_REG				0x0414
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D26_REG				0x0418
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D27_REG				0x041c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D28_REG				0x0420
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D29_REG				0x0424
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D30_REG				0x0428
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_D31_REG				0x042c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A16_REG				0x0430
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A17_REG				0x0434
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A18_REG				0x0438
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A19_REG				0x043c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A20_REG				0x0440
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A21_REG				0x0444
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A22_REG				0x0448
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A23_REG				0x044c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A24_REG				0x0450
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A25_REG				0x0454
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A26_REG				0x0458
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_A27_REG				0x045c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_EB0_REG				0x0460
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_EB1_REG				0x0464
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_EB2_REG				0x0468
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_EB3_REG				0x046c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_OE_REG				0x0470
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_CS0_REG				0x0474
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_CS1_REG				0x0478
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_CS2_REG				0x047c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_CS3_REG				0x0480
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_CS4_REG				0x0484
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_CS5_REG				0x0488
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_DTACK_REG			0x048c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_WAIT_REG			0x0490
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_LBA_REG				0x0494
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_BCLK_REG			0x0498
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_RW_REG				0x049c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_CRE_REG				0x04a0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_RAS_REG			0x04a4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_CAS_REG			0x04a8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDWE_REG			0x04ac
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE0_REG			0x04b0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCKE1_REG			0x04b4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDCLK_REG			0x04b8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS0_REG			0x04bc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS1_REG			0x04c0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS2_REG			0x04c4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_SDQS3_REG			0x04c8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS0_REG			0x04cc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_CS1_REG			0x04d0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM0_REG			0x04d4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM1_REG			0x04d8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM2_REG			0x04dc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DRAM_DQM3_REG			0x04e0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_WE_B_REG			0x04e4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_RE_B_REG			0x04e8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_ALE_REG			0x04ec
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CLE_REG			0x04f0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_WP_B_REG			0x04f4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_RB0_REG			0x04f8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_RB1_REG			0x04fc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_RB2_REG			0x0500
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_RB3_REG			0x0504
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_SDBA2_REG			0x0508
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_SDODT1_REG			0x050c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_EIM_SDODT0_REG			0x0510
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO_NAND_REG			0x0514
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CS0_REG			0x0518
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CS1_REG			0x051c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CS2_REG			0x0520
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CS3_REG			0x0524
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CS4_REG			0x0528
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CS5_REG			0x052c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CS6_REG			0x0530
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_CS7_REG			0x0534
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_RDY_INT_REG			0x0538
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D15_REG			0x053c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D14_REG			0x0540
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D13_REG			0x0544
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D12_REG			0x0548
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D11_REG			0x054c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D10_REG			0x0550
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D9_REG			0x0554
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D8_REG			0x0558
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D7_REG			0x055c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D6_REG			0x0560
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D5_REG			0x0564
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D4_REG			0x0568
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D3_REG			0x056c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D2_REG			0x0570
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D1_REG			0x0574
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_NANDF_D0_REG			0x0578
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D8_REG				0x057c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D9_REG				0x0580
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D10_REG			0x0584
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D11_REG			0x0588
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D12_REG			0x058c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D13_REG			0x0590
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D14_REG			0x0594
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D15_REG			0x0598
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D16_REG			0x059c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D17_REG			0x05a0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D18_REG			0x05a4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_D19_REG			0x05a8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_VSYNC_REG			0x05ac
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_HSYNC_REG			0x05b0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_PIXCLK_REG			0x05b4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI1_MCLK_REG			0x05b8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_D12_REG			0x05bc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_D13_REG			0x05c0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_D14_REG			0x05c4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_D15_REG			0x05c8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_D16_REG			0x05cc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_D17_REG			0x05d0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_D18_REG			0x05d4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_D19_REG			0x05d8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_VSYNC_REG			0x05dc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_HSYNC_REG			0x05e0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSI2_PIXCLK_REG			0x05e4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_I2C1_CLK_REG			0x05e8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_I2C1_DAT_REG			0x05ec
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_AUD3_BB_TXD_REG			0x05f0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_AUD3_BB_RXD_REG			0x05f4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_AUD3_BB_CK_REG			0x05f8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_AUD3_BB_FS_REG			0x05fc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSPI1_MOSI_REG			0x0600
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSPI1_MISO_REG			0x0604
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSPI1_SS0_REG			0x0608
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSPI1_SS1_REG			0x060c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSPI1_RDY_REG			0x0610
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CSPI1_SCLK_REG			0x0614
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_UART1_RXD_REG			0x0618
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_UART1_TXD_REG			0x061c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_UART1_RTS_REG			0x0620
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_UART1_CTS_REG			0x0624
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_UART2_RXD_REG			0x0628
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_UART2_TXD_REG			0x062c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_UART3_RXD_REG			0x0630
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_UART3_TXD_REG			0x0634
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_OWIRE_LINE_REG			0x0638
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW0_REG			0x063c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW1_REG			0x0640
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW2_REG			0x0644
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_ROW3_REG			0x0648
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_COL0_REG			0x064c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_COL1_REG			0x0650
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_COL2_REG			0x0654
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_COL3_REG			0x0658
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_COL4_REG			0x065c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_KEY_COL5_REG			0x0660
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_JTAG_TCK_REG			0x0664
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_JTAG_TMS_REG			0x0668
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_JTAG_TDI_REG			0x066c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_JTAG_TRSTB_REG			0x0670
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_JTAG_MOD_REG			0x0674
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_CLK_REG			0x0678
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DIR_REG			0x067c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_STP_REG			0x0680
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_NXT_REG			0x0684
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DATA0_REG			0x0688
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DATA1_REG			0x068c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DATA2_REG			0x0690
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DATA3_REG			0x0694
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DATA4_REG			0x0698
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DATA5_REG			0x069c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DATA6_REG			0x06a0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_USBH1_DATA7_REG			0x06a4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_PIN11_REG			0x06a8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_PIN12_REG			0x06ac
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_PIN13_REG			0x06b0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_D0_CS_REG			0x06b4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_D1_CS_REG			0x06b8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISPB2_SER_DIN_REG			0x06bc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISPB2_SER_DIO_REG			0x06c0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISPB2_SER_CLK_REG			0x06c4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISPB2_SER_RS_REG			0x06c8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT0_REG			0x06cc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT1_REG			0x06d0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT2_REG			0x06d4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT3_REG			0x06d8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT4_REG			0x06dc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT5_REG			0x06e0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT6_REG			0x06e4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT7_REG			0x06e8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT8_REG			0x06ec
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT9_REG			0x06f0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT10_REG			0x06f4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT11_REG			0x06f8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT12_REG			0x06fc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT13_REG			0x0700
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT14_REG			0x0704
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT15_REG			0x0708
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT16_REG			0x070c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT17_REG			0x0710
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT18_REG			0x0714
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT19_REG			0x0718
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT20_REG			0x071c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT21_REG			0x0720
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT22_REG			0x0724
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP1_DAT23_REG			0x0728
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_PIN3_REG			0x072c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_DISP_CLK_REG			0x0730
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_PIN2_REG			0x0734
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI1_PIN15_REG			0x0738
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI_GP1_REG				0x073c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI_GP2_REG				0x0740
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI_GP3_REG				0x0744
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI2_PIN4_REG			0x0748
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI2_PIN2_REG			0x074c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI2_PIN3_REG			0x0750
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI2_DISP_CLK_REG			0x0754
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DI_GP4_REG				0x0758
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT0_REG			0x075c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT1_REG			0x0760
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT2_REG			0x0764
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT3_REG			0x0768
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT4_REG			0x076c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT5_REG			0x0770
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT6_REG			0x0774
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT7_REG			0x0778
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT8_REG			0x077c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT9_REG			0x0780
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT10_REG			0x0784
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT11_REG			0x0788
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT12_REG			0x078c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT13_REG			0x0790
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT14_REG			0x0794
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_DISP2_DAT15_REG			0x0798
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD1_CMD_REG				0x079c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD1_CLK_REG				0x07a0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA0_REG			0x07a4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA1_REG			0x07a8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA2_REG			0x07ac
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD1_DATA3_REG			0x07b0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_0_REG				0x07b4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_1_REG				0x07b8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_REG				0x07bc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_REG				0x07c0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_REG			0x07c4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_REG			0x07c8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_REG			0x07cc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_REG			0x07d0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_2_REG				0x07d4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_3_REG				0x07d8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_RESET_IN_B_REG			0x07dc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_POR_B_REG				0x07e0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_BOOT_MODE1_REG			0x07e4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_BOOT_MODE0_REG			0x07e8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_PMIC_RDY_REG			0x07ec
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CKIL_REG				0x07f0
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_PMIC_STBY_REQ_REG			0x07f4
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_PMIC_ON_REQ_REG			0x07f8
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_PMIC_INT_REQ_REG			0x07fc
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_CLK_SS_REG				0x0800
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_4_REG				0x0804
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_5_REG				0x0808
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_6_REG				0x080c
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_7_REG				0x0810
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_8_REG				0x0814
#define IMX51_IOMUXC_SW_PAD_CTL_PAD_GPIO1_9_REG				0x0818
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_CSI2_PKE0_REG			0x081c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DDRPKS_REG				0x0820
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EIM_SR1_REG				0x0824
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DISP2_PKE0_REG			0x0828
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DRAM_B4_REG				0x082c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_INDDR_REG				0x0830
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EIM_SR2_REG				0x0834
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_PKEDDR_REG				0x0838
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DDR_A0_REG				0x083c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EMI_PKE0_REG			0x0840
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EIM_SR3_REG				0x0844
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DDR_A1_REG				0x0848
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DDRAPUS_REG				0x084c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EIM_SR4_REG				0x0850
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EMI_SR5_REG				0x0854
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EMI_SR6_REG				0x0858
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_HYSDDR0_REG				0x085c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_CSI1_PKE0_REG			0x0860
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_HYSDDR1_REG				0x0864
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DISP1_PKE0_REG			0x0868
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_HYSDDR2_REG				0x086c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_HVDDR_REG				0x0870
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_HYSDDR3_REG				0x0874
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DRAM_SR_B0_REG			0x0878
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DDRAPKS_REG				0x087c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DRAM_SR_B1_REG			0x0880
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DDRPUS_REG				0x0884
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EIM_DS1_REG				0x0888
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DRAM_SR_B2_REG			0x088c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_PKEADDR_REG				0x0890
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EIM_DS2_REG				0x0894
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EIM_DS3_REG				0x0898
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DRAM_SR_B4_REG			0x089c
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_INMODE1_REG				0x08a0
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DRAM_B0_REG				0x08a4
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EIM_DS4_REG				0x08a8
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DRAM_B1_REG				0x08ac
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DDR_SR_A0_REG			0x08b0
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EMI_DS5_REG				0x08b4
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DRAM_B2_REG				0x08b8
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_DDR_SR_A1_REG			0x08bc
#define IMX51_IOMUXC_SW_PAD_CTL_GRP_EMI_DS6_REG				0x08c0
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_SR_SLOW		0x00000000
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_SR_FAST		0x00000001
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_DS(n)		(((n) & 3) << 1)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_DS_LOW		IMX51_IOMUXC_SW_PAD_CTL_PAD_DS(0)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_DS_MEDIUM		IMX51_IOMUXC_SW_PAD_CTL_PAD_DS(1)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_DS_HIGH		IMX51_IOMUXC_SW_PAD_CTL_PAD_DS(2)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_DS_MAX		IMX51_IOMUXC_SW_PAD_CTL_PAD_DS(3)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_OD_DISABLE		0x00000000
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_OD_ENABLE		0x00000004
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_PUS(n)		(((n) & 3) << 4)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_PUS_100K_PULLDOWN	IMX51_IOMUXC_SW_PAD_CTL_PAD_PUS(0)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_PUS_47K_PULLUP	IMX51_IOMUXC_SW_PAD_CTL_PAD_PUS(1)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_PUS_100K_PULLUP	IMX51_IOMUXC_SW_PAD_CTL_PAD_PUS(2)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_PUS_22K_PULLUP	IMX51_IOMUXC_SW_PAD_CTL_PAD_PUS(3)
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_PU_KEEPER		0x00000000
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_PU_PULL		0x00000040
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_PK_DISABLE		0x00000000
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_PK_ENABLE		0x00000080
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_HYS_DISABLE	0x00000000
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_HYS_ENABLE		0x00000100
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_HV_DISABLE		0x00000000
# define IMX51_IOMUXC_SW_PAD_CTL_PAD_HV_ENABLE		0x00002000

#define IMX51_IOMUXC_AUDMUX_P4_INPUT_DA_AMX_SELECT_INPUT_REG		0x08c4
#define IMX51_IOMUXC_AUDMUX_P4_INPUT_DB_AMX_SELECT_INPUT_REG		0x08c8
#define IMX51_IOMUXC_AUDMUX_P4_INPUT_TXCLK_AMX_SELECT_INPUT_REG		0x08cc
#define IMX51_IOMUXC_AUDMUX_P4_INPUT_TXFS_AMX_SELECT_INPUT_REG		0x08d0
#define IMX51_IOMUXC_AUDMUX_P5_INPUT_DA_AMX_SELECT_INPUT_REG		0x08d4
#define IMX51_IOMUXC_AUDMUX_P5_INPUT_DB_AMX_SELECT_INPUT_REG		0x08d8
#define IMX51_IOMUXC_AUDMUX_P5_INPUT_RXCLK_AMX_SELECT_INPUT_REG		0x08dc
#define IMX51_IOMUXC_AUDMUX_P5_INPUT_RXFS_AMX_SELECT_INPUT_REG		0x08e0
#define IMX51_IOMUXC_AUDMUX_P5_INPUT_TXCLK_AMX_SELECT_INPUT_REG		0x08e4
#define IMX51_IOMUXC_AUDMUX_P5_INPUT_TXFS_AMX_SELECT_INPUT_REG		0x08e8
#define IMX51_IOMUXC_AUDMUX_P6_INPUT_DA_AMX_SELECT_INPUT_REG		0x08ec
#define IMX51_IOMUXC_AUDMUX_P6_INPUT_DB_AMX_SELECT_INPUT_REG		0x08f0
#define IMX51_IOMUXC_AUDMUX_P6_INPUT_RXCLK_AMX_SELECT_INPUT_REG		0x08f4
#define IMX51_IOMUXC_AUDMUX_P6_INPUT_RXFS_AMX_SELECT_INPUT_REG		0x08f8
#define IMX51_IOMUXC_AUDMUX_P6_INPUT_TXCLK_AMX_SELECT_INPUT_REG		0x08fc
#define IMX51_IOMUXC_AUDMUX_P6_INPUT_TXFS_AMX_SELECT_INPUT_REG		0x0900
#define IMX51_IOMUXC_CCM_IPP_DI0_CLK_SELECT_INPUT_REG			0x0904
#define IMX51_IOMUXC_CCM_IPP_DI1_CLK_SELECT_INPUT_REG			0x0908
#define IMX51_IOMUXC_CCM_PLL1_BYPASS_CLK_SELECT_INPUT_REG		0x090c
#define IMX51_IOMUXC_CCM_PLL2_BYPASS_CLK_SELECT_INPUT_REG		0x0910
#define IMX51_IOMUXC_CSPI_IPP_CSPI_CLK_IN_SELECT_INPUT_REG		0x0914
#define IMX51_IOMUXC_CSPI_IPP_IND_MISO_SELECT_INPUT_REG			0x0918
#define IMX51_IOMUXC_CSPI_IPP_IND_MOSI_SELECT_INPUT_REG			0x091c
#define IMX51_IOMUXC_CSPI_IPP_IND_SS1_B_SELECT_INPUT_REG		0x0920
#define IMX51_IOMUXC_CSPI_IPP_IND_SS2_B_SELECT_INPUT_REG		0x0924
#define IMX51_IOMUXC_CSPI_IPP_IND_SS3_B_SELECT_INPUT_REG		0x0928
#define IMX51_IOMUXC_DPLLIP1_L1T_TOG_EN_SELECT_INPUT_REG		0x092c
#define IMX51_IOMUXC_ECSPI2_IPP_IND_SS_B_1_SELECT_INPUT_REG		0x0930
#define IMX51_IOMUXC_ECSPI2_IPP_IND_SS_B_3_SELECT_INPUT_REG		0x0934
#define IMX51_IOMUXC_EMI_IPP_IND_RDY_INT_SELECT_INPUT_REG		0x0938
#define IMX51_IOMUXC_ESDHC3_IPP_DAT0_IN_SELECT_INPUT_REG		0x093c
#define IMX51_IOMUXC_ESDHC3_IPP_DAT1_IN_SELECT_INPUT_REG		0x0940
#define IMX51_IOMUXC_ESDHC3_IPP_DAT2_IN_SELECT_INPUT_REG		0x0944
#define IMX51_IOMUXC_ESDHC3_IPP_DAT3_IN_SELECT_INPUT_REG		0x0948
#define IMX51_IOMUXC_FEC_FEC_COL_SELECT_INPUT_REG			0x094c
#define IMX51_IOMUXC_FEC_FEC_CRS_SELECT_INPUT_REG			0x0950
#define IMX51_IOMUXC_FEC_FEC_MDI_SELECT_INPUT_REG			0x0954
#define IMX51_IOMUXC_FEC_FEC_RDATA_0_SELECT_INPUT_REG			0x0958
#define IMX51_IOMUXC_FEC_FEC_RDATA_1_SELECT_INPUT_REG			0x095c
#define IMX51_IOMUXC_FEC_FEC_RDATA_2_SELECT_INPUT_REG			0x0960
#define IMX51_IOMUXC_FEC_FEC_RDATA_3_SELECT_INPUT_REG			0x0964
#define IMX51_IOMUXC_FEC_FEC_RX_CLK_SELECT_INPUT_REG			0x0968
#define IMX51_IOMUXC_FEC_FEC_RX_DV_SELECT_INPUT_REG			0x096c
#define IMX51_IOMUXC_FEC_FEC_RX_ER_SELECT_INPUT_REG			0x0970
#define IMX51_IOMUXC_FEC_FEC_TX_CLK_SELECT_INPUT_REG			0x0974
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_1_SELECT_INPUT_REG		0x0978
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_2_SELECT_INPUT_REG		0x097c
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_3_SELECT_INPUT_REG		0x0980
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_4_SELECT_INPUT_REG		0x0984
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_5_SELECT_INPUT_REG		0x0988
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_6_SELECT_INPUT_REG		0x098c
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_7_SELECT_INPUT_REG		0x0990
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_8_SELECT_INPUT_REG		0x0994
#define IMX51_IOMUXC_GPIO3_IPP_IND_G_IN_12_SELECT_INPUT_REG		0x0998
#define IMX51_IOMUXC_HSC_MIPI_MIX_IPP_IND_SENS1_DATA_EN_SELECT_I_REG	0x099c
#define IMX51_IOMUXC_HSC_MIPI_MIX_IPP_IND_SENS2_DATA_EN_SELECT_I_REG	0x09a0
#define IMX51_IOMUXC_HSC_MIPI_MIX_PAR0_VSYNC_SELECT_INPUT_REG		0x09a4
#define IMX51_IOMUXC_HSC_MIPI_MIX_PAR1_DI_WAIT_SELECT_INPUT_REG		0x09a8
#define IMX51_IOMUXC_HSC_MIPI_MIX_PAR_SISG_TRIG_SELECT_INPUT_REG	0x09ac
#define IMX51_IOMUXC_I2C1_IPP_SCL_IN_SELECT_INPUT_REG			0x09b0
#define IMX51_IOMUXC_I2C1_IPP_SDA_IN_SELECT_INPUT_REG			0x09b4
#define IMX51_IOMUXC_I2C2_IPP_SCL_IN_SELECT_INPUT_REG			0x09b8
#define IMX51_IOMUXC_I2C2_IPP_SDA_IN_SELECT_INPUT_REG			0x09bc
#define IMX51_IOMUXC_IPU_IPP_DI_0_IND_DISPB_SD_D_SELECT_INPUT_REG	0x09c0
#define IMX51_IOMUXC_IPU_IPP_DI_1_IND_DISPB_SD_D_SELECT_INPUT_REG	0x09c4
#define IMX51_IOMUXC_KPP_IPP_IND_COL_6_SELECT_INPUT_REG			0x09c8
#define IMX51_IOMUXC_KPP_IPP_IND_COL_7_SELECT_INPUT_REG			0x09cc
#define IMX51_IOMUXC_KPP_IPP_IND_ROW_4_SELECT_INPUT_REG			0x09d0
#define IMX51_IOMUXC_KPP_IPP_IND_ROW_5_SELECT_INPUT_REG			0x09d4
#define IMX51_IOMUXC_KPP_IPP_IND_ROW_6_SELECT_INPUT_REG			0x09d8
#define IMX51_IOMUXC_KPP_IPP_IND_ROW_7_SELECT_INPUT_REG			0x09dc
#define IMX51_IOMUXC_UART1_IPP_UART_RTS_B_SELECT_INPUT_REG		0x09e0
#define IMX51_IOMUXC_UART1_IPP_UART_RXD_MUX_SELECT_INPUT_REG		0x09e4
#define IMX51_IOMUXC_UART2_IPP_UART_RTS_B_SELECT_INPUT_REG		0x09e8
#define IMX51_IOMUXC_UART2_IPP_UART_RXD_MUX_SELECT_INPUT_REG		0x09ec
#define IMX51_IOMUXC_UART3_IPP_UART_RTS_B_SELECT_INPUT_REG		0x09f0
#define IMX51_IOMUXC_UART3_IPP_UART_RXD_MUX_SELECT_INPUT_REG		0x09f4
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_CLK_SELECT_INPUT_REG		0x09f8
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DATA_0_SELECT_INPUT_REG		0x09fc
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DATA_1_SELECT_INPUT_REG		0x0a00
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DATA_2_SELECT_INPUT_REG		0x0a04
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DATA_3_SELECT_INPUT_REG		0x0a08
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DATA_4_SELECT_INPUT_REG		0x0a0c
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DATA_5_SELECT_INPUT_REG		0x0a10
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DATA_6_SELECT_INPUT_REG		0x0a14
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DATA_7_SELECT_INPUT_REG		0x0a18
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_DIR_SELECT_INPUT_REG		0x0a1c
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_NXT_SELECT_INPUT_REG		0x0a20
#define IMX51_IOMUXC_USBOH3_IPP_IND_UH3_STP_SELECT_INPUT_REG		0x0a24
# define IMX51_IOMUXC_DAISY0				0x00000000
# define IMX51_IOMUXC_DAISY1				0x00000001
# define IMX51_IOMUXC_DAISY2				0x00000002
# define IMX51_IOMUXC_DAISY3				0x00000003
# define IMX51_IOMUXC_DAISY4				0x00000004
# define IMX51_IOMUXC_DAISY5				0x00000005
# define IMX51_IOMUXC_DAISY6				0x00000006
# define IMX51_IOMUXC_DAISY7				0x00000007
# define IMX51_IOMUXC_DAISY				IMX51_IOMUXC_DAISY1

#define AXI_IOMUXC_MUX(axi, name, mux)					\
	axi_iomux_set(axi, IMX51_IOMUXC_SW_MUX_CTL_PAD_##name##_REG,	\
	    IMX51_IOMUXC_SW_MUX_CTL_PAD_##mux)

#define AXI_IOMUXC_PAD(axi, name, pad)					\
	axi_iomux_set(axi, IMX51_IOMUXC_SW_PAD_CTL_PAD_##name##_REG,	\
	    pad)

#define AXI_IOMUXC_MUXPAD(axi, name, mux, pad)				\
	do {								\
		AXI_IOMUXC_MUX(axi, name, mux);			\
		AXI_IOMUXC_PAD(axi, name, pad);			\
	} while (0 /* CONSTCOND */)

#endif /* _ARM_IMX_IMX51_IOMUXREG_H_ */
